/*
 *   Copyright (C)2004-2011 Sir Pustekuchen
 *
 *   Author   :  Sir Pustekuchen
 *   Home     :  http://birth-of-the-empires.de
 *
 */

#pragma once
#include "Events/EventScreen.h"

class CEventGameOver : public CEventScreen
{
public:
	DECLARE_SERIAL (CEventGameOver)

	/// Standardkonstruktor
	CEventGameOver(void) {};

	/// Standardkonstruktor mit Parameterbergabe
	CEventGameOver(const CString& sPlayersRace);

	/// Standarddestruktor
	~CEventGameOver(void);

	virtual void Create(void);

	virtual void Close(void);

	// Zeichenfunktionen
	virtual void Draw(Graphics* g, CGraphicPool* graphicPool) const;
};
